local FULL_BAR = "lllllllllllllllllllllllllllllllllllllllll"
local POS_X = -99
local POS_Y = -220
local BARS_N = 10

local DEBUFFS =
{
	"Cheap Shot", "Garrote - Silence", "Sap", "Kidney Shot", "Blind", "Dismantle", "Gouge",
	"Corruption", "Curse of Agony", "Curse of Tongues", "Curse of Exhaustion", "Fear", "Howl of Terror", "Unstable Affliction",
		"Shadow Embrace", "Haunt", "Seed of Corruption", "Immolate", "Shadowfury", "Shadowflame", "Death Coil", "Seduction",
		"Banish", "Intercept",
	"Devouring Plague", "Shadow Word: Pain", "Psychic Scream", "Vampiric Embrace", "Vampiric Touch", "Psychic Horror",
		"Silence", "Shackle Undead", "Mind Soothe",
	"Polymorph", "Frost Nova", "Frostbolt", "Dragon's Breath", "Living Bomb", "Slow", "Frostbite", "Freeze", "Deep Freeze",
		"Shattered Barrier", "Cone of Cold", "Silenced - Improved Counterspell", "Blast Wave",
	"Frost Fever", "Blood Plague", "Chains of Ice", "Strangulate", "Crypt Fever", "Hungering Cold", "Ebon Plague",
		"Unholy Blight", "Mark of Blood", "Dancing Rune Weapon",
	"Faerie Fire", "Faerie Fire (Feral)", "Feral Charge - Bear", "Feral Charge - Cat", "Bash", "Hibernate", "Cyclone",
		"Soothe Animal", "Entangling Roots", "Rake", "Lacerate", "Moonfire", "Maim", "Demoralizing Roar", "Pounce",
		"Mangle (Cat)", "Rip", "Mangle (Bear)", "Infected Wounds", "Insect Swarm",
	"Flame Shock", "Hex", "Stormstrike",
	"Concussive Shot", "Wing Clip", "Scorpid Sting", "Viper Sting", "Scare Beast", "Hunter's Mark", "Serpent Sting",
		"Freezing Trap", "Immolation Trap", "Black Arrow", "Intimidation", "Silencing Shot", "Aimed Shot", "Scatter Shot",
		"Wyvern Sting", "Black Arrow", "Explosive Shot", "Counterattack",
	"Judgement of Light", "Judgement of Wisdom", "Turn Evil", "Judgement of Justice", "Hammer of Justice", "Holy Wrath",
		"Seal of Vengeance", "Seal of Corruption", "Repentance", "Avenger's Shield",
	"Hamstring", "Sunder Armor", "Dazed", "Disarm", "Intimidating Shout", "Intercept", "Charge Stun", "Shattering Throw",
		"Rend", "Thunder Clap", "Demoralizing Shout", "Deep Wounds", "Mortal Strike", "Piercing Howl", "Shockwave",
		"Concussion Blow", "Furious Attacks", "Improved Hamstring"
}

local Frames = {}
local Textures = {}
local Digits = {}
local Bars = {}

local SpellNames = {}
local SpellDurs = {}
local SpellExps = {}
local TargetNames = {}
local BarRatios = {}

local function ShowBar(i)
	Frames[i]:Show()
	Digits[i]:Show()
	Bars[i]:Show()
end

local function HideBar(i)
	Frames[i]:Hide()
	Digits[i]:Hide()
	Bars[i]:Hide()
end

local function GetRelatedColor(max, left)
	local cur = 2 * left / max

	if cur > 1 then
		return 2 - cur, 1, 0
	else
		return 1, cur, 0
	end
end

local function SpellInFilter(spell)
	for _, debuff in pairs(DEBUFFS) do
		if debuff == spell then
			return true
		end
	end
	return false
end

local function CheckSpell(spell, unit)
	for i = 1, 40 do
		local name, _, icon, _, _, dur, exp, caster = UnitDebuff(unit, i)
		if name ~= nil and caster == "player" and name == spell then
			return dur, exp, icon
		end
	end
end

local function AddSpell(spell, dur, exp, icon, name)
	local free
	for i in pairs(Bars) do
		if not free and not Bars[i]:IsVisible() then
			free = i
		elseif Bars[i]:IsVisible() and SpellNames[i] == spell and TargetNames[i] == name then
			SpellDurs[i] = dur
			SpellExps[i] = exp
			BarRatios[i] = string.len(FULL_BAR) / dur
			return
		end
	end

	if free then
		SpellNames[free] = spell
		SpellDurs[free] = dur
		SpellExps[free] = exp
		TargetNames[free] = name
		BarRatios[free] = string.len(FULL_BAR) / dur
		Textures[free]:SetTexture(icon)
		ShowBar(free)
	end
end

local Units = { "target", "focus", "mouseover" }

local function ScanTargets(spell, name)
	for _, unit in pairs(Units) do
		if UnitExists(unit) and UnitName(unit) == name then
			local dur, exp, icon = CheckSpell(spell, unit)
			if dur then
				AddSpell(spell, dur, exp, icon, name)
				return
			end
		end
	end
end

function TextEnemyDebuffsTimers_OnLoad()
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

	for i = 1, BARS_N do
		Digits[i] = UIParent:CreateFontString(nil, "GameFontNormal")
		Digits[i]:SetFont(STANDARD_TEXT_FONT, 14, "OUTLINE")
		Digits[i]:SetPoint("RIGHT", UIParent, "CENTER", POS_X, POS_Y + i * 17)
		Frames[i] = CreateFrame("Frame", nil, UIParent)
		Frames[i]:SetWidth(16)
		Frames[i]:SetHeight(16)
		Frames[i]:SetPoint("LEFT", UIParent, "CENTER", POS_X + 5, POS_Y + i * 17)
		Frames[i]:SetFrameStrata("LOW")
		Textures[i] = Frames[i]:CreateTexture(nil, "BACKGROUND")
		Textures[i]:SetAllPoints(true)
		Textures[i]:SetTexCoord(0.07, 0.9, 0.07, 0.9)
		Textures[i]:SetAlpha(0.7)
		Bars[i] = UIParent:CreateFontString(nil, "GameFontNormal")
		Bars[i]:SetFont(STANDARD_TEXT_FONT, 14, "OUTLINE, MONOCHROME")
		Bars[i]:SetPoint("LEFT", UIParent, "CENTER", POS_X + 26, POS_Y + i * 17)
		HideBar(i)
	end
end

function TextEnemyDebuffsTimers_OnEvent()
	if (arg2 == "SPELL_AURA_APPLIED" or arg2 == "SPELL_AURA_APPLIED_DOSE" or arg2 == "SPELL_AURA_REFRESH") and
		bit.band(arg5, 0x101) == 0x101 and bit.band(arg8, 0x10) ~= 0x10 then
			if SpellInFilter(arg10) then
				ScanTargets(arg10, arg7)
			end
	elseif arg2 == "SPELL_AURA_REMOVED" and bit.band(arg5, 0x101) == 0x101 and bit.band(arg8, 0x10) ~= 0x10 then
		for i in pairs(Bars) do
			if Bars[i]:IsVisible() and SpellNames[i] == arg10 and TargetNames[i] == arg7 then
				HideBar(i)
				return
			end
		end	
	end
end

function TextEnemyDebuffsTimers_OnUpdate()
	for i in pairs(Bars) do
		if Bars[i]:IsVisible() then
			local rem = SpellExps[i] - GetTime()
			if rem <= 0 then
				HideBar(i)
			else
				Digits[i]:SetText(ceil(rem))
				local r, g, b = GetRelatedColor(SpellDurs[i], rem)
				Digits[i]:SetTextColor(r, g, b)
				Bars[i]:SetText(string.sub(FULL_BAR, 1, ceil(rem * BarRatios[i])))
				Bars[i]:SetTextColor(r, g, b)
				Bars[i]:SetAlphaGradient(10, 70)
			end
		end
	end
end